<template>
	<div>
		<!-- 奖扣ab分弹窗 -->
		<el-dialog :title="title" :visible.sync="visible"  :close-on-click-modal="false" :before-close="closeDialog" width="600px">
			<div>
				<el-form :model="dialogData" ref="dialogData" label-width="80px" v-loading="loading">
					<div v-for="(item, index) in dialogData.items" :key="index" @click="itemIndex = index">
						<div style="overflow: hidden;" class="flex-box flex-v-ce">
							<span style="line-height: 36px;" class="flex-1">申请明细({{ index + 1 }})</span>
							<el-button type="text" v-show="index > 0 || dialogData.items.length > 1" @click="delItem(index)">删除</el-button>
						</div>
						<el-form-item label="录入对象" :prop="'items.'+ index +'.employeeName'" :rules="[{ required: true, message: '请选择录入对象', trigger: 'change' }]">
						  <el-row>
							<el-col :span="18">
							  <el-input auto-complete="off" v-model="item.employeeName" placeholder="请选择录入对象"></el-input>
							  <div @click="item.show_employee_selector = true" style=" position: absolute; top: 0; right: 0; left: 0; bottom: 0; z-index: 9;"></div>
							</el-col>
						  </el-row>
							<el-dialog title="选择人员" width="640px" :visible.sync="item.show_employee_selector" append-to-body :before-close="handleClose">
								<EmployeeSelector
									v-if="item.show_employee_selector"
									ref="employee"
									:multi="false"
									:user_no_select="false"
									:can_select_dept="false"
									:selected="item.employee_selected"
									@confirm="employee_confirm"
								/>
								<span slot="footer" class="dialog-footer">
									<el-button @click="item.show_employee_selector = false">取 消</el-button>
									<el-button type="primary" @click="submitMembers('employee')">确 定</el-button>
								</span>
							</el-dialog>
						</el-form-item>
						<el-form-item label="指定规则">
							<el-switch v-model="item.rule_switch" @change="switchChange(index, item.rule_switch)" active-color="#13ce66"></el-switch>
						</el-form-item>
						
						<el-form-item
							label="选择规则"
							v-if="item.rule_switch"
							:prop="'items.' + index + '.rule_item_list_value'"
							:rules="[{ required: true, message: '请选择规则', trigger: 'change' }]"
						>
							<el-cascader
								v-model="item.rule_item_list_value"
								ref="ruleItem"
								:popper-class="'itemClass'"
								:options="rule_item_list"
								@change="ruleItemChange"
								:show-all-levels="false"
								:props="{ children: 'child', label: 'name', value: 'id' }"
							></el-cascader>
						</el-form-item>

						<el-form-item v-if="item.rule_switch && item.rule_id">
							<div style="line-height: 24px;" v-show="item.rule_item_details.range_type == 1">
								{{ item.rule_item_details.min_point }}
								<span class="blue">{{ get_point_name(item.rule_item_details.pt_id) }}</span>
							</div>
							<div style="line-height: 24px;" v-show="item.rule_item_details.range_type == 2">
								{{ item.rule_item_details.min_point }} ~ {{ item.rule_item_details.max_point }}
								<span class="blue">{{ get_point_name(item.rule_item_details.pt_id) }}</span>
							</div>
							<div style="line-height: 24px;">{{ item.rule_item_details.name }}</div>
						</el-form-item>

						<el-form-item label="发生时间" :prop="'items.' + index + '.event_time'" :rules="[{ required: true, message: '请选择时间', trigger: 'blur' }]">
							<el-row>
								<el-col :span="18">
									<el-date-picker v-model="item.event_time" type="date" placeholder="请选择时间" value-format="yyyy-MM-dd"></el-date-picker>
								</el-col>
							</el-row>
						</el-form-item>

						<el-form-item
							label="事件内容"
							:prop="'items.' + index + '.remark'"
							:rules="[{ required: true, message: '请输入事件内容', trigger: 'blur' }, { min: 3, max: 100, message: '长度在 3 到 100 个字符', trigger: 'blur' }]"
						>
							<el-row>
								<el-col :span="18"><el-input type="textarea" rows="3" placeholder="请输入事件内容" style="width: 100%;" v-model="item.remark"></el-input></el-col>
							</el-row>
						</el-form-item>

						<el-form-item label="图片" label-width="100px">
							<uploadOss
								:headers="Xtoken"
								class="avatar-uploader"
								:action="'https://' + 'integralsys.oss-cn-shenzhen.aliyuncs.com'"
								:show-file-list="true"
								:file-list="item.fileList"
								:on-success="handleFilesSuccess"
								:on-preview="onFilePreView"
								:before-upload="beforeUpload"
								:on-remove="onFileRemove"
								:limit="3"
								:multiple="true"
								ref="clearPicture"
							>
								<el-button size="small" type="primary">点击上传</el-button>
								（最多选择3张）
							</uploadOss>
						</el-form-item>

						<el-form-item v-loading.lock="fullscreenLoading" label="审批人" :prop="'items.' + index + '.approvalName'" :rules="[{ required: true, message: '请选择审批人', trigger: 'blur' }]">
							<el-row>
								<el-col :span="18">
									<el-input auto-complete="off" v-model="item.approvalName" placeholder="请选择审批人"></el-input>
									<div  @click="approval_selected_null(item)" style=" position: absolute; top: 0; right: 0; left: 0; bottom: 0; z-index: 9;"></div>
								</el-col>
							</el-row>
							<el-dialog title="选择人员" width="640px" :visible.sync="item.show_approval_selector" append-to-body :before-close="handleClose">
								<EmployeeSelector
									:can_select_employee="true"
									v-if="item.show_approval_selector"
									ref="approval"
									:multi="false"
									:employee_list="item.approval_employee_list"
									:user_no_select="false"
									:can_select_dept="false"
									:selected="item.approval_selected"
									@confirm="approval_confirm"
								/>
								<span slot="footer" class="dialog-footer">
									<el-button @click="item.show_approval_selector = false">取 消</el-button>
									<el-button type="primary" @click="submitApproval('approval')">确 定</el-button>
								</span>
							</el-dialog>
						</el-form-item>
					</div>
					<el-form-item style="margin-bottom: 0;"><div>如需录入多条，请点击“增加一条”</div></el-form-item>
					<el-form-item style="margin-bottom: 0;"><el-button type="primary" plain @click="addItem">+ 增加一条</el-button></el-form-item>
					<el-form-item style="text-align: right; margin-bottom: 0;">
						<el-button @click="closeDialog('dialogData')">取 消</el-button>
						<el-button :disabled="btn_loading" :loading="btn_loading" type="primary" @click="subData('dialogData')">确 认</el-button>
					</el-form-item>
				</el-form>
			</div>
		</el-dialog>

		<el-dialog :title="'提交结果'" :visible.sync="error_list_show" :append-to-body="true" width="700px">
			<el-table :data="error_list">
				<el-table-column prop="target" label="员工"></el-table-column>
				<el-table-column prop="point" label="积分"></el-table-column>
				<el-table-column prop="status" label="处理状态">
					<template slot-scope="scope">
						<span :style="'color:' + (scope.row.status == 0 ? '#f70000' : '#47bf47')">{{ scope.row.status == 0 ? '申请失败' : '申请成功' }}</span>
					</template>
				</el-table-column>
				<el-table-column prop="msg" label="备注信息"></el-table-column>
			</el-table>
		</el-dialog>
	</div>
</template>

<script>
import moment from 'moment';
import EmployeeSelector from '@/components/EmployeeSelector';
import uploadOss from '@/components/upload';

export default {
	name: 'applicationIntegration',
	// 数据
	model: {
		prop: 'list',
		event: 'value'
	},
	props: {
		title: {
			type: String,
			default: ''
		},
		visible: {
			type: Boolean,
			default: false
		},
		integralType: {
			type: Number,
			default: 0
		}
	},
	data() {
		var getUserData = this.$getUserData();
		return {
			error_list: [], //错误信息数组
			error_list_show: false, //错误信息弹窗
			Xtoken: { 'X-Token': this.$getToken() },
			loading: false,
			dialogData: {
				items: [
					{
						rule_switch: true,
						rule_id: '',
						item_id: '',
						remark: '',
						event_time: moment().format('YYYY-MM-DD'),

						// 录入对象
						employee_id: getUserData.id,
						employeeName: getUserData.name,
						employee_selected: {dept: [],employee:[{id:getUserData.id,name:getUserData.name}]},
						show_employee_selector: false,

						// 审批人信息
						reviewer_id: '',
						approvalName: '',
						approval_selected: { dept: [], employee: [] },
						approval_employee_list: [],//当前选中人的 上级
						show_approval_selector: false,

						// 附件
						fileList: [],
						files: [],
						// 规则分类 与 规则细则 名称
						rule_list_value: null,
						rule_item_list_value: null,
						rule_item_details: { range_type: '' }
					}
				]
			},
			// 规则分类
			rule_list: [],
			// 规则细则
			rule_item_list: [],
			flatteningIntegralRules: null,
			user_info: null,
			btn_loading: false,
			itemIndex:0,
			fullscreenLoading: false,//选择审批人时需要，获取录入对象的上级
			LocalValObj:{id:'',name:''},//当前录入的审批人缓存
		};
	},
	components: { EmployeeSelector, uploadOss },
	created() {
		this.user_info = this.$getUserData();
		var reviewerObj=this.getLocalVal(this.user_info.id);
		var reviewerObj=reviewerObj? JSON.parse(reviewerObj):{id:'',name:''};
		this.LocalValObj=reviewerObj
	},
	mounted() {
		this.getRuleItemData();
		// 初始化审批人
		if(this.LocalValObj.id){
			this.dialogData.items[0].approval_selected.employee =[this.LocalValObj];
			this.dialogData.items[0].reviewer_id = this.LocalValObj.id
			this.dialogData.items[0].approvalName = this.LocalValObj.name
		}
	},
	methods: {
		//获取缓存起来的审批人
		getLocalVal(id){
		  var obj=localStorage.getItem(id);
		  return obj
		},
		submitMembers(name){
			this.$refs[name][0].confirm(); //调用组件的confirm（）；
		},
		submitApproval(name) {
			this.$refs[name][0].confirm(); //调用组件的confirm（）；
		},
		//关闭
		handleClose(done) {
			done();
		},
		// 附件上传
		beforeUpload(file) {
			const isJPG = /^image\/(jpeg|png|jpg)$/.test(file.type);
			const isLt2M = file.size / 1024 / 1024 < 1;
			if (!isJPG) {
				this.$message.error('上传头像图片只能是 JPG 格式!');
			}
			if (!isLt2M) {
				this.$message.error('上传头像图片大小不能超过 2MB!');
			}
			return isJPG && isLt2M;
		},
		onFilePreView(file) {
			window.open(file.response.url, '_blank');
		},
		onFileRemove(file, fileList) {
			this.dialogData.items[this.itemIndex].fileList = fileList;
			this.dialogData.items[this.itemIndex].files = [];
			fileList.forEach((element, index) => {
				this.dialogData.items[this.itemIndex].files.push(element.url);
			});
		},
		handleFilesSuccess(response, file, fileList) {
			this.dialogData.items[this.itemIndex].fileList = fileList;
			this.dialogData.items[this.itemIndex].files = [];
			fileList.forEach((element, index) => {
				this.dialogData.items[this.itemIndex].files.push(element.url);
			});
		},

		// 选择审批人前提
		approval_selected_null(item) {
			if(!item.employee_id){
				this.$message.error('请先选择录入对象');
			}else{
				this.fullscreenLoading=true;
				this.getEmployeeList(item.employee_id,function(res){
					if(res.length>0){
					item.approval_employee_list=res;	
					item.show_approval_selector = true;
					}else{
						this.$message.error('您没有审批人，请联系管理员');
					}
				})
			}
		},
		  //获取人员（上级人员）
		  getEmployeeList(userIdArr, callBack) {
			this.$axios('get',"api/employee/superior", { employee_id: userIdArr, filter_applyor: 1 }).then((res) => {
			  callBack(res.data.data.list)
			}).finally(()=>{
				this.fullscreenLoading=false;
			})
		  },
		// 获取规则信息
		getRuleData() {
			let data = {
				cycle_type: '1'
			};
			this.integralType === 1 ? (data.pt_id = '1') : this.integralType === 2 ? (data.pt_id = '2') : (data.pt_id = '3');
			this.$axios('get', '/api/integral/rule/trees', data)
				.then(res => {
					if (res.data.code == 1) {
						const resultData = res.data.data;
						this.rule_list = resultData.rule_tree;
					}
					this.rule_list = this.getTreeData(this.rule_list);
				})
		},
		// 获取规则细则
		getRuleItemData() {
			let data = { cycle_type: '1' };
			this.loading = true;
			this.$axios('get', '/api/integral/rule/trees', data, 'v2').then(res => {
				if (res.data.code == 1) {
					const resultData = res.data.data;
					this.rule_item_list = resultData.tree;
					this.flatteningIntegralRules = this.getItemDetail(this.rule_item_list);
					this.loading = false;
				}
			})
		},
		// 规则细则变化关闭down
		ruleItemChange(value) {
			const item = this.dialogData.items[this.itemIndex];
			let ruleItemDetail = null;
			this.flatteningIntegralRules.forEach(element => {
				if (element.id == value[value.length - 1]) {
					ruleItemDetail = { ...element };
				}
			});
			item.rule_item_details = ruleItemDetail;
			item.remark = ruleItemDetail.name;
			item.rule_id = ruleItemDetail.pid;
			item.item_id = value[value.length - 1];
			this.$refs.ruleItem.dropDownVisible = false;
		},
		// 规则分类变化关闭dewn
		ruleChange(value) {
			this.dialogData.items[this.itemIndex].rule_id = value[value.length - 1];
			this.$refs.rule.dropDownVisible = false;
		},
		// 递归判断列表，把最后的child设为undefined
		getTreeData(data) {
			for (var i = 0; i < data.length; i++) {
				if (data[i].child.length < 1) {
					// child若为空数组，则将child设为undefined
					data[i].child = undefined;
				} else {
					// child若不为空数组，则继续 递归调用 本方法
					this.getTreeData(data[i].child);
				}
			}
			return data;
		},
		// 选择对象
		employee_confirm(data){
		  const item = this.dialogData.items[this.itemIndex]
		  item.employeeName = ''
		  item.employee_selected = {dept: [],employee:[]}
		  item.employee_id = ''
		  
		  if (data.employee !== null && data.employee.length != 0) {
		    item.employeeName = data.employee[0].name
		    item.employee_selected.employee = [{name: data.employee[0].name,id:data.employee[0].id,img_url: data.employee[0].img_url}]
		    item.employee_id = data.employee[0].id
			
			var reviewerObj=this.getLocalVal(data.employee[0].id);
			var reviewerObj=reviewerObj? JSON.parse(reviewerObj):{id:'',name:''};
			// 清空审批人数据
			if(reviewerObj.id){
				item.approval_selected={ dept: [], employee: [reviewerObj] };
			}else{
				item.approval_selected={ dept: [], employee: [] };
			}
			item.reviewer_id= reviewerObj.id;
			item.approvalName= reviewerObj.name;
			item.approval_employee_list=[];//当前选中人的 上级
		  }
		  item.show_employee_selector=false
		},

		getItemDetail(arr) {
			let result = [];
			for (const item of arr) {
				var res = JSON.parse(JSON.stringify(item)); // 先克隆一份数据作为第一层级的填充
				delete res['child'];
				result.push(res);
				if (item.child instanceof Array && item.child.length > 0) {
					// 如果当前child为数组并且长度大于0，才可进入getItemDetail()方法
					result = result.concat(this.getItemDetail(item.child));
				}
			}
			return result;
		},
		// 加一条
		addItem() {
			this.dialogData.items.push({
				rule_switch: true,
				rule_id: '',
				item_id: '',
				remark: '',
				event_time: moment().format('YYYY-MM-DD'),

				// 录入对象
				employee_id: this.user_info.id,
				employeeName: this.user_info.name,
				employee_selected: {dept: [],employee:[{id: this.user_info.id ,img_url: this.user_info.img_url,name: this.user_info.name}]},
				show_employee_selector: false,

				// 审批人信息
				reviewer_id: this.LocalValObj.id,
				approvalName: this.LocalValObj.name,
				approval_selected: { dept: [], employee:this.LocalValObj.id? [this.LocalValObj]:[] },
				approval_employee_list: [],//当前选中人的 上级
				show_approval_selector: false,

				// 附件
				fileList: [],
				files: [],
				// 规则分类 与 规则细则 名称
				rule_list_value: null,
				rule_item_list_value: null,
				rule_item_details: { range_type: '' }
			});
		},
		closeDialog(formName) {
			this.dialogData.items=[{
				rule_switch: true,
				rule_id: '',
				item_id: '',
				remark: '',
				event_time: moment().format('YYYY-MM-DD'),
			
				// 录入对象
				employee_id: this.user_info.id,
				employeeName: this.user_info.name,
				employee_selected: {dept: [],employee:[{id: this.user_info.id ,img_url: this.user_info.img_url,name: this.user_info.name}]},
				show_employee_selector: false,
			
				// 审批人信息
				reviewer_id: '',
				approvalName: '',
				approval_employee_list: [],//当前选中人的 上级
				approval_selected: { dept: [], employee: [] },
				show_approval_selector: false,
			
				// 附件
				fileList: [],
				files: [],
				// 规则分类 与 规则细则 名称
				rule_list_value: null,
				rule_item_list_value: null,
				rule_item_details: { range_type: '' }
			}];
			
			this.$emit('update:visible', false);
		},
		delItem(index) {
			this.$confirm('你确定要删除奖扣明细' + parseInt(index + 1) + '吗?', '提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning'
			})
				.then(() => {
					this.dialogData.items.splice(index, 1);
					this.$message({
						type: 'success',
						message: '删除成功!'
					});
				})
		},
		subData(formName) {
			this.$refs[formName].validate(valid => {
				if (valid) {
					this.btn_loading = true;
					this.save();
				}
			});
		},
		// 提交数据
		save() {
			let data = { items: [] };
			this.dialogData.items.forEach(element => {
				data.items.push({
					rule_id: element.rule_id || 0,
					employee_id: element.employee_id,
					item_id: element.item_id || 0,
					remark: element.remark,
					event_time: element.event_time,
					pt_id: element.pt_id,
					reviewer_id: element.reviewer_id || 0,
					approvalName:element.approvalName,
					files: element.files
				});
			});
			this.$axios('post', '/api/integral/review/apply', data)
			.then(res => {
					if (res.data.code == 1) {
						this.closeDialog();
						this.$message.success(res.data.msg);
						this.error_list = res.data.data.list;
						this.error_list_show = true;
					} else {
						this.$message.error(res.data.msg);
					}
			}).finally(()=>{
				this.btn_loading = false;
				data.items.forEach(element => {
					localStorage.setItem(element.employee_id,JSON.stringify({id:element.reviewer_id,name:element.approvalName}))
				});
			})
		},
		// 当switch 改变了
		switchChange(index, value) {
			this.itemIndex = index;
			const item = this.dialogData.items[this.itemIndex];
			if (!value) {
				item.rule_id = '';
				item.item_id = '';
				item.rule_item_list_value = '';
				item.rule_item_details = { range_type: '' };
			} else {
				item.rule_id = '';
				item.rule_list_value = '';
			}
		},
		// 选择审核人
		approval_confirm(data) {
			const item = this.dialogData.items[this.itemIndex];
			item.approvalName = '';
			item.approval_selected = { dept: [], employee: [] };
			item.reviewer_id = '';
			if (data.employee !== null && data.employee.length != 0) {
				item.approvalName = data.employee[0].name;
				item.approval_selected.employee = [{ name: data.employee[0].name, id: data.employee[0].id, img_url: data.employee[0].img_url }];
				item.reviewer_id = data.employee[0].id;
			}
			item.show_approval_selector = false;
		},
		// 获取积分名称
		get_point_name(id) {
			return this.$getTyps(id).name;
		},
	}
};
</script>
<style lang="scss">
.itemClass .el-cascader-menu .el-cascader-menu__wrap li.el-cascader-node {
	height: auto;
	max-width: 500px;
	.el-cascader-node__label {
		white-space: initial;
		overflow: initial;
		text-overflow: initial;
	}
}
</style>
